这道题看起来还是比较复杂的，可能出现的情况很多，不过可以通过 `*` 来入手分析，不管是什么字符，即便是 `.`，如果后面跟着的不是 `*`，那么匹配起来是很轻松的，可以如下穷举：

- s 为 `null`，p 为 `null`，返回 `true`；
- p[1] 等于 `*`，前部分匹配为空，则 p 前两个字符无效；前部分匹配一个字符，则进入下一次递归；
- p[1] 不等于 `*`，那么只需要对比第一个字符就行了，匹配通过的话，s 和 p 的前一个字符就无效了，进入下一次递归。

具体实现如下：

```js
function isMatch(s, p) {
  if (!s && !p) return true;
  if (p && p[1] === '*') {
    return (
      // Skip First Token, Match next token
      isMatch(s, p.slice(2)) || 
      // Matched First Token, Match next token
      (s[0] === p[0] || p[0] === '.') && isMatch(s.slice(1), p)
    );
  } else {
    return (
      // Matched First Token, Match next token
      (s[0] === p[0] || p[0] === '.') && isMatch(s.slice(1), p.slice(1))
    );
  }
}

console.assert(isMatch('aa', 'a') === false, 1);
console.assert(isMatch('aa', 'aa') === true, 2);
console.assert(isMatch('aaa', 'aa') === false, 3);
console.assert(isMatch('aa', 'a*') === true, 4);
console.assert(isMatch('aa', '.*') === true, 5);
console.assert(isMatch('ab', '.*') === true, 6);
console.assert(isMatch('aab', 'c*a*b') === true, 7);
```

by @barretlee
